import argparse
import asyncio
import json

import aiohttp

from v6d0auth import certs
from v6d0auth.config import host, port

parser = argparse.ArgumentParser()
parser.add_argument('requester', type=str)
parser.add_argument('role', type=str)


async def main():
    requester = bytes.fromhex(args.requester)
    role = args.role
    async with aiohttp.ClientSession() as session:
        # noinspection HttpUrlsUsage
        async with session.ws_connect(f'http://{host}:{port}/remove_role') as ws:
            nonce = await ws.receive_bytes()
            await ws.send_bytes(certs.sign(json.dumps([[requester.hex(), role], nonce.hex()]).encode()))
            print((await ws.receive_bytes()).hex())


if __name__ == '__main__':
    args = parser.parse_args()
    asyncio.run(main())
